"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _nativeBase = require("native-base");
var _maskField = _interopRequireDefault(require("../Masks/maskField"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const Input = _ref => {
  let {
    name,
    label,
    errorInfo,
    isRequired = true,
    setFieldValue,
    mask,
    initialValue,
    setFieldTouched,
    touched,
    maskLength,
    ErrorBox,
    ...rest
  } = _ref;
  const refValue = (0, _react.useRef)((0, _maskField.default)({
    text: initialValue,
    mask
  }).masked);
  const handleOnChangeText = text => {
    const hardValue = (0, _maskField.default)({
      text,
      mask
    }).unmasked;
    if (maskLength) {
      const {
        masked
      } = (0, _maskField.default)({
        text: hardValue.slice(0, maskLength),
        mask
      });
      refValue.current = masked;
    } else {
      const {
        masked
      } = (0, _maskField.default)({
        text: hardValue,
        mask
      });
      refValue.current = masked;
    }
  };
  return /*#__PURE__*/_react.default.createElement(_nativeBase.FormControl, {
    isRequired: isRequired,
    isInvalid: !!errorInfo && !!touched
  }, /*#__PURE__*/_react.default.createElement(_nativeBase.FormControl.Label, null, label), /*#__PURE__*/_react.default.createElement(_nativeBase.Input, _extends({
    onChangeText: text => {
      handleOnChangeText(text);
      setFieldValue(name, text);
    },
    onBlur: () => setFieldTouched(name),
    value: refValue.current
  }, rest)), touched && errorInfo ? ErrorBox ? ErrorBox(errorInfo) : typeof errorInfo === 'string' ? /*#__PURE__*/_react.default.createElement(_nativeBase.FormControl.ErrorMessage, {
    leftIcon: /*#__PURE__*/_react.default.createElement(_nativeBase.WarningOutlineIcon, {
      size: "xs"
    })
  }, errorInfo) : errorInfo.map(error => {
    return /*#__PURE__*/_react.default.createElement(_nativeBase.FormControl.ErrorMessage, {
      leftIcon: /*#__PURE__*/_react.default.createElement(_nativeBase.WarningOutlineIcon, {
        size: "xs"
      })
    }, error);
  }) : /*#__PURE__*/_react.default.createElement(_nativeBase.FormControl.HelperText, null, "\xA0"));
};
var _default = /*#__PURE__*/(0, _react.memo)(Input);
exports.default = _default;
//# sourceMappingURL=Input.js.map