"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _nativeBase = require("native-base");
var _MaterialIcons = _interopRequireDefault(require("react-native-vector-icons/MaterialIcons"));
var _maskField = _interopRequireDefault(require("../Masks/maskField"));
var _styles = _interopRequireDefault(require("./styles"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const InputWithHelp = _ref => {
  let {
    message,
    name,
    label,
    errorInfo,
    isRequired = true,
    mask,
    initialValue,
    setFieldValue,
    setFieldTouched,
    touched,
    ErrorBox,
    ...rest
  } = _ref;
  const toast = (0, _nativeBase.useToast)();
  const refValue = (0, _react.useRef)((0, _maskField.default)({
    text: initialValue,
    mask
  }).masked);
  const handleOnChangeText = text => {
    const {
      masked,
      unmasked
    } = (0, _maskField.default)({
      text,
      mask
    });
    refValue.current = masked;
    setFieldValue(name, unmasked);
  };
  console.log('Render: ', name, ' Error: ', errorInfo);
  return /*#__PURE__*/_react.default.createElement(_nativeBase.FormControl, {
    isRequired: isRequired,
    isInvalid: !!errorInfo && !!touched
  }, /*#__PURE__*/_react.default.createElement(_nativeBase.FormControl.Label, null, label), /*#__PURE__*/_react.default.createElement(_nativeBase.Input, _extends({
    onChangeText: handleOnChangeText,
    value: refValue.current,
    InputRightElement: /*#__PURE__*/_react.default.createElement(_nativeBase.Icon, {
      as: _MaterialIcons.default,
      name: "help",
      style: _styles.default.iconHelp.style,
      onPress: () => toast.show({
        description: message,
        placement: 'top',
        duration: 2000
      })
    }),
    onBlur: () => setFieldTouched(name)
  }, rest)), touched && errorInfo ? ErrorBox ? ErrorBox(errorInfo) : typeof errorInfo === 'string' ? /*#__PURE__*/_react.default.createElement(_nativeBase.FormControl.ErrorMessage, {
    leftIcon: /*#__PURE__*/_react.default.createElement(_nativeBase.WarningOutlineIcon, {
      size: "xs"
    })
  }, errorInfo) : errorInfo.map(error => {
    return /*#__PURE__*/_react.default.createElement(_nativeBase.FormControl.ErrorMessage, {
      leftIcon: /*#__PURE__*/_react.default.createElement(_nativeBase.WarningOutlineIcon, {
        size: "xs"
      })
    }, error);
  }) : /*#__PURE__*/_react.default.createElement(_nativeBase.FormControl.HelperText, null, "\xA0"));
};
var _default = /*#__PURE__*/(0, _react.memo)(InputWithHelp);
exports.default = _default;
//# sourceMappingURL=InputTextWithHelp.js.map