"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ZIP_CODE_BRL = exports.ZIP_CODE = exports.USA_PHONE = exports.USA_KM = exports.ONLY_NUMBERS = exports.DATE_YYYYMMDD = exports.DATE_MMDDYYYY = exports.DATE_DDMMYYYY = exports.CREDIT_CARD = exports.BRL_PHONE_CELL = exports.BRL_PHONE = exports.BRL_KM = exports.BRL_CURRENCY = exports.BRL_CPF_CNPJ = exports.BRL_CPF = exports.BRL_CNPJ = exports.BRL_CELL = exports.BRL_CAR_PLATE = void 0;
var _createNumberMask = _interopRequireDefault(require("./createNumberMask"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const BRL_CAR_PLATE = [/[a-zA-Z]/, /[a-zA-Z]/, /[a-zA-Z]/, '-', /\d/, /\w/, /\d/, /\d/];
exports.BRL_CAR_PLATE = BRL_CAR_PLATE;
const BRL_CNPJ = [/\d/, /\d/, '.', /\d/, /\d/, /\d/, '.', /\d/, /\d/, /\d/, '/', /\d/, /\d/, /\d/, /\d/, '-', /\d/, /\d/];
exports.BRL_CNPJ = BRL_CNPJ;
const BRL_CPF = [/\d/, /\d/, /\d/, '.', /\d/, /\d/, /\d/, '.', /\d/, /\d/, /\d/, '-', /\d/, /\d/];
exports.BRL_CPF = BRL_CPF;
const BRL_CPF_CNPJ = text => {
  const rawValue = (text === null || text === void 0 ? void 0 : text.replace(/\D+/g, '')) || '';
  return rawValue.length <= 11 ? BRL_CPF : BRL_CNPJ;
};
exports.BRL_CPF_CNPJ = BRL_CPF_CNPJ;
const BRL_CURRENCY = (0, _createNumberMask.default)({
  prefix: ['R', '$', ' '],
  separator: ',',
  delimiter: '.',
  precision: 2
});
exports.BRL_CURRENCY = BRL_CURRENCY;
const BRL_KM = (0, _createNumberMask.default)({
  separator: ',',
  delimiter: '.',
  precision: 1
});
exports.BRL_KM = BRL_KM;
const USA_KM = (0, _createNumberMask.default)({
  separator: '.',
  delimiter: ',',
  precision: 1
});
exports.USA_KM = USA_KM;
const USA_PHONE = ['(', /[2-9]/, /\d/, /\d/, ')', ' ', /[2-9]/, /\d/, /\d/, '-', /\d/, /\d/, /\d/, /\d/];
exports.USA_PHONE = USA_PHONE;
const BRL_PHONE = ['(', /\d/, /\d/, ')', ' ', /\d/, /\d/, /\d/, /\d/, '-', /\d/, /\d/, /\d/, /\d/];
exports.BRL_PHONE = BRL_PHONE;
const BRL_CELL = ['(', /\d/, /\d/, ')', ' ', /\d/, /\d/, /\d/, /\d/, /\d/, '-', /\d/, /\d/, /\d/, /\d/];
exports.BRL_CELL = BRL_CELL;
const ONLY_NUMBERS = [/\d/, /\d/, /\d/, /\d/, /\d/, /\d/, /\d/, /\d/, /\d/, /\d/];
exports.ONLY_NUMBERS = ONLY_NUMBERS;
const BRL_PHONE_CELL = text => {
  const rawValue = (text === null || text === void 0 ? void 0 : text.replace(/\D+/g, '')) || '';
  return rawValue.length <= 10 ? BRL_PHONE : BRL_CELL;
};
exports.BRL_PHONE_CELL = BRL_PHONE_CELL;
const CREDIT_CARD = [/\d/, /\d/, /\d/, /\d/, ' ', [/\d/], [/\d/], [/\d/], [/\d/], ' ', [/\d/], [/\d/], [/\d/], [/\d/], ' ', /\d/, /\d/, /\d/, /\d/];
exports.CREDIT_CARD = CREDIT_CARD;
const DATE_DDMMYYYY = function () {
  let text = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  const cleanText = text.replace(/\D+/g, '');
  let secondDigitDayMask = /\d/;
  if (cleanText.charAt(0) === '0') {
    secondDigitDayMask = /[1-9]/;
  }
  if (cleanText.charAt(0) === '3') {
    secondDigitDayMask = /[01]/;
  }
  let secondDigitMonthMask = /\d/;
  if (cleanText.charAt(2) === '0') {
    secondDigitMonthMask = /[1-9]/;
  }
  if (cleanText.charAt(2) === '1') {
    secondDigitMonthMask = /[012]/;
  }
  return [/[0-3]/, secondDigitDayMask, '/', /[0-1]/, secondDigitMonthMask, '/', /\d/, /\d/, /\d/, /\d/];
};
exports.DATE_DDMMYYYY = DATE_DDMMYYYY;
const DATE_MMDDYYYY = function () {
  let text = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  const cleanText = text.replace(/\D+/g, '');
  let secondDigitMonthMask = /\d/;
  if (cleanText.charAt(0) === '0') {
    secondDigitMonthMask = /[1-9]/;
  }
  if (cleanText.charAt(0) === '1') {
    secondDigitMonthMask = /[012]/;
  }
  let secondDigitDayMask = /\d/;
  if (cleanText.charAt(2) === '0') {
    secondDigitDayMask = /[1-9]/;
  }
  if (cleanText.charAt(2) === '3') {
    secondDigitDayMask = /[01]/;
  }
  return [/[0-1]/, secondDigitMonthMask, '/', /[0-3]/, secondDigitDayMask, '/', /\d/, /\d/, /\d/, /\d/];
};
exports.DATE_MMDDYYYY = DATE_MMDDYYYY;
const DATE_YYYYMMDD = function () {
  let text = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  const cleanText = text.replace(/\D+/g, '');
  let secondDigitMonthMask = /\d/;
  if (cleanText.charAt(4) === '0') {
    secondDigitMonthMask = /[1-9]/;
  }
  if (cleanText.charAt(4) === '1') {
    secondDigitMonthMask = /[012]/;
  }
  let secondDigitDayMask = /\d/;
  if (cleanText.charAt(6) === '0') {
    secondDigitDayMask = /[1-9]/;
  }
  if (cleanText.charAt(6) === '3') {
    secondDigitDayMask = /[01]/;
  }
  return [/\d/, /\d/, /\d/, /\d/, '/', /[0-1]/, secondDigitMonthMask, '/', /[0-3]/, secondDigitDayMask];
};
exports.DATE_YYYYMMDD = DATE_YYYYMMDD;
const ZIP_CODE_BRL = [/\d/, /\d/, /\d/, /\d/, /\d/, '-', /\d/, /\d/, /\d/];
exports.ZIP_CODE_BRL = ZIP_CODE_BRL;
const ZIP_CODE_USA = [/\d/, /\d/, /\d/, /\d/, /\d/];
const ZIP_CODE = text => {
  const rawValue = (text === null || text === void 0 ? void 0 : text.replace(/\D+/g, '')) || '';
  return rawValue.length > 5 ? ZIP_CODE_BRL : ZIP_CODE_USA;
};
exports.ZIP_CODE = ZIP_CODE;
//# sourceMappingURL=masks.js.map