function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import React, { memo, useRef } from 'react';
import { FormControl, Input as InputNB, WarningOutlineIcon } from 'native-base';
import maskField from '../Masks/maskField';
const Input = _ref => {
  let {
    name,
    label,
    errorInfo,
    isRequired = true,
    setFieldValue,
    mask,
    initialValue,
    setFieldTouched,
    touched,
    maskLength,
    ErrorBox,
    ...rest
  } = _ref;
  const refValue = useRef(maskField({
    text: initialValue,
    mask
  }).masked);
  const handleOnChangeText = text => {
    const hardValue = maskField({
      text,
      mask
    }).unmasked;
    if (maskLength) {
      const {
        masked
      } = maskField({
        text: hardValue.slice(0, maskLength),
        mask
      });
      refValue.current = masked;
    } else {
      const {
        masked
      } = maskField({
        text: hardValue,
        mask
      });
      refValue.current = masked;
    }
  };
  return /*#__PURE__*/React.createElement(FormControl, {
    isRequired: isRequired,
    isInvalid: !!errorInfo && !!touched
  }, /*#__PURE__*/React.createElement(FormControl.Label, null, label), /*#__PURE__*/React.createElement(InputNB, _extends({
    onChangeText: text => {
      handleOnChangeText(text);
      setFieldValue(name, text);
    },
    onBlur: () => setFieldTouched(name),
    value: refValue.current
  }, rest)), touched && errorInfo ? ErrorBox ? ErrorBox(errorInfo) : typeof errorInfo === 'string' ? /*#__PURE__*/React.createElement(FormControl.ErrorMessage, {
    leftIcon: /*#__PURE__*/React.createElement(WarningOutlineIcon, {
      size: "xs"
    })
  }, errorInfo) : errorInfo.map(error => {
    return /*#__PURE__*/React.createElement(FormControl.ErrorMessage, {
      leftIcon: /*#__PURE__*/React.createElement(WarningOutlineIcon, {
        size: "xs"
      })
    }, error);
  }) : /*#__PURE__*/React.createElement(FormControl.HelperText, null, "\xA0"));
};
export default /*#__PURE__*/memo(Input);
//# sourceMappingURL=Input.js.map