function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
/* eslint-disable react/no-children-prop */
import React, { memo, useRef } from 'react';
import { FormControl, Input as InputNB, InputGroup as InputGroupNB, InputLeftAddon, WarningOutlineIcon, Text } from 'native-base';
import maskField from '../Masks/maskField';
import styles from './styles';
const InputGroup = _ref => {
  let {
    name,
    label,
    errorInfo,
    isRequired = true,
    setFieldValue,
    prefix,
    mask,
    initialValue,
    setFieldTouched,
    touched,
    ErrorBox,
    ...rest
  } = _ref;
  const refValue = useRef(maskField({
    text: initialValue,
    mask
  }).masked);
  const handleOnChangeText = text => {
    const {
      masked,
      unmasked
    } = maskField({
      text,
      mask
    });
    refValue.current = masked;
    setFieldValue(name, unmasked);
  };
  return /*#__PURE__*/React.createElement(FormControl, {
    isRequired: isRequired,
    isInvalid: !!errorInfo && !!touched
  }, /*#__PURE__*/React.createElement(FormControl.Label, null, label), /*#__PURE__*/React.createElement(InputGroupNB, null, /*#__PURE__*/React.createElement(InputLeftAddon, _extends({
    children: /*#__PURE__*/React.createElement(Text, {
      style: styles.prefix.style
    }, prefix)
  }, styles.leftAddon)), /*#__PURE__*/React.createElement(InputNB, _extends({
    w: "87%",
    onChangeText: text => {
      handleOnChangeText(text);
    },
    onBlur: () => setFieldTouched(name),
    value: refValue.current
  }, styles.input, rest))), touched && errorInfo ? ErrorBox ? ErrorBox(errorInfo) : typeof errorInfo === 'string' ? /*#__PURE__*/React.createElement(FormControl.ErrorMessage, {
    leftIcon: /*#__PURE__*/React.createElement(WarningOutlineIcon, {
      size: "xs"
    })
  }, errorInfo) : errorInfo.map(error => {
    return /*#__PURE__*/React.createElement(FormControl.ErrorMessage, {
      leftIcon: /*#__PURE__*/React.createElement(WarningOutlineIcon, {
        size: "xs"
      })
    }, error);
  }) : /*#__PURE__*/React.createElement(FormControl.HelperText, null, "\xA0"));
};
export default /*#__PURE__*/memo(InputGroup);
//# sourceMappingURL=InputTextGroup.js.map