function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import React, { memo, useRef } from 'react';
import { FormControl, Input as InputNB, WarningOutlineIcon, useToast, Icon } from 'native-base';
import MaterialIcons from 'react-native-vector-icons/MaterialIcons';
import maskField from '../Masks/maskField';
import styles from './styles';
const InputWithHelp = _ref => {
  let {
    message,
    name,
    label,
    errorInfo,
    isRequired = true,
    mask,
    initialValue,
    setFieldValue,
    setFieldTouched,
    touched,
    ErrorBox,
    ...rest
  } = _ref;
  const toast = useToast();
  const refValue = useRef(maskField({
    text: initialValue,
    mask
  }).masked);
  const handleOnChangeText = text => {
    const {
      masked,
      unmasked
    } = maskField({
      text,
      mask
    });
    refValue.current = masked;
    setFieldValue(name, unmasked);
  };
  console.log('Render: ', name, ' Error: ', errorInfo);
  return /*#__PURE__*/React.createElement(FormControl, {
    isRequired: isRequired,
    isInvalid: !!errorInfo && !!touched
  }, /*#__PURE__*/React.createElement(FormControl.Label, null, label), /*#__PURE__*/React.createElement(InputNB, _extends({
    onChangeText: handleOnChangeText,
    value: refValue.current,
    InputRightElement: /*#__PURE__*/React.createElement(Icon, {
      as: MaterialIcons,
      name: "help",
      style: styles.iconHelp.style,
      onPress: () => toast.show({
        description: message,
        placement: 'top',
        duration: 2000
      })
    }),
    onBlur: () => setFieldTouched(name)
  }, rest)), touched && errorInfo ? ErrorBox ? ErrorBox(errorInfo) : typeof errorInfo === 'string' ? /*#__PURE__*/React.createElement(FormControl.ErrorMessage, {
    leftIcon: /*#__PURE__*/React.createElement(WarningOutlineIcon, {
      size: "xs"
    })
  }, errorInfo) : errorInfo.map(error => {
    return /*#__PURE__*/React.createElement(FormControl.ErrorMessage, {
      leftIcon: /*#__PURE__*/React.createElement(WarningOutlineIcon, {
        size: "xs"
      })
    }, error);
  }) : /*#__PURE__*/React.createElement(FormControl.HelperText, null, "\xA0"));
};
export default /*#__PURE__*/memo(InputWithHelp);
//# sourceMappingURL=InputTextWithHelp.js.map