import formatWithMask from './formatWithMask';
const maskField = _ref => {
  let {
    text = '',
    mask
  } = _ref;
  let maskData = {
    masked: text,
    unmasked: text,
    obfuscated: text
  };
  if (mask && text) {
    const maskUtil = typeof mask === 'function' ? mask(text) : mask;
    const maskResult = formatWithMask({
      text,
      mask: maskUtil
    });
    maskData = Object.assign(maskData, maskResult);
  }
  return maskData;
};
export default maskField;
//# sourceMappingURL=maskField.js.map